package ac.ed.lurg.country.gams;

import ac.ed.lurg.types.CommodityType;

public class GamsCommodityDemand {

	private CommodityType commodity;
	private double subsistence;
	private double discretionary;
	private double kcalPerT;

	public GamsCommodityDemand(CommodityType commodity, double subsistence, double discretionary, double kcalPerT) {
		this.commodity = commodity;
		this.subsistence = subsistence;
		this.discretionary = discretionary;
		this.kcalPerT = kcalPerT;
	}

	public double getSubsistence() {
		return subsistence;
	}

	public double getDiscretionary() {
		return discretionary;
	}

	public double getKcalTotal() {
		return (subsistence+ discretionary) * 2000;
	}

	public double getPlumDemand() {	
		return (getKcalTotal() > 0 ? getKcalTotal()*365/kcalPerT : 0.0);
	}

	public CommodityType getCommodity() {
		return commodity;
	}

	@Override
	public String toString() {
		return String.format("%14s:  subs=%.3f,\tdisc=%.3f,\tdemand(kcal)=%.1f,\tdemand(plum)= %.3f", commodity, subsistence, discretionary, getKcalTotal(), getPlumDemand()); 
	}
}