package ac.ed.lurg.country.gams;

import java.util.Map;

import ac.ed.lurg.Timestep;
import ac.ed.lurg.landuse.CarbonFluxItem;
import ac.ed.lurg.landuse.IrrigationItem;
import ac.ed.lurg.landuse.LandUseItem;
import ac.ed.lurg.landuse.WoodYieldItem;
import ac.ed.lurg.types.LandCoverType;
import ac.ed.lurg.utils.DoubleMap;
import ac.ed.lurg.yield.YieldResponsesItem;

public class GamsLocationInput {
	
	private Timestep timestep;
	private Map<Integer, ? extends YieldResponsesItem> yields;
	private Map<Integer, ? extends LandUseItem> previousLandUse;
	private Map<Integer, ? extends IrrigationItem> irrigationCosts;
	private Map<Integer, ? extends CarbonFluxItem> carbonFluxes;
	private Map<Integer, ? extends WoodYieldItem> woodYields;
	private DoubleMap<Integer, LandCoverType, Double> minimumLandCover;
	private DoubleMap<Integer, LandCoverType, Double> timberYield;
	private Map<Integer, Double> naturalWoodYieldFactor;
	private DoubleMap<LandCoverType, LandCoverType, Double> conversionCosts;
	private GamsCountryInput countryInput;
	
	public GamsLocationInput(Timestep timestep, Map<Integer, ? extends YieldResponsesItem> yields, Map<Integer, ? extends LandUseItem> previousLandUse,
			Map<Integer, ? extends IrrigationItem> irrigationCosts, Map<Integer, ? extends CarbonFluxItem> carbonFluxes, 
			Map<Integer, ? extends WoodYieldItem> woodYields, DoubleMap<Integer, LandCoverType, Double> minimumLandCover, 
			DoubleMap<Integer, LandCoverType, Double> timberYield, Map<Integer, Double> naturalWoodYieldFactor,
			DoubleMap<LandCoverType, LandCoverType, Double> conversionCosts, GamsCountryInput countryInput) {
		super();
		this.timestep = timestep;
		this.yields = yields;
		this.previousLandUse = previousLandUse;
		this.irrigationCosts = irrigationCosts;
		this.carbonFluxes = carbonFluxes;
		this.woodYields = woodYields;
		this.minimumLandCover = minimumLandCover;
		this.timberYield = timberYield;
		this.naturalWoodYieldFactor = naturalWoodYieldFactor;
		this.conversionCosts = conversionCosts;
		this.countryInput = countryInput;	
	}
		
	public Map<Integer, ? extends YieldResponsesItem> getYields() {
		return yields;
	}
	
	public Map<Integer, ? extends LandUseItem> getPreviousLandUse() {
		return previousLandUse;
	}
	
	public Map<Integer, ? extends IrrigationItem> getIrrigationCosts() {
		return irrigationCosts;
	}
	
	public Map<Integer, ? extends CarbonFluxItem> getCarbonFluxes() {
		return carbonFluxes;
	}
	
	public Map<Integer, ? extends WoodYieldItem> getWoodYields() {
		return woodYields;
	}
	
	public DoubleMap<Integer, LandCoverType, Double> getMinimumLandCover() {
		return minimumLandCover;
	}
	
	public DoubleMap<Integer, LandCoverType, Double> getTimberYield() {
		return timberYield;
	}
	
	public Map<Integer, Double> getNaturalWoodYieldFactor() {
		return naturalWoodYieldFactor;
	}
	
	public DoubleMap<LandCoverType, LandCoverType, Double> getConversionCosts() {
		return conversionCosts;
	}
	
	public GamsCountryInput getCountryInput() {
		return countryInput;
	}
	
	public Timestep getTimestep() {
		return timestep;
	}
}
