package ac.ed.lurg.country.gams;

import java.util.List;
import java.util.Map;

import com.gams.api.GAMSGlobals.ModelStat;

import ac.ed.lurg.landuse.CropUsageData;
import ac.ed.lurg.landuse.LandUseItem;
import ac.ed.lurg.types.CropType;
import ac.ed.lurg.utils.DoubleMap;
import ac.ed.lurg.utils.TripleMap;
import ac.ed.lurg.types.LandCoverType;
import ac.ed.lurg.country.ForestRecord;

public class GamsLocationOutput {
	ModelStat status;
	
	Map<Integer, LandUseItem> landUses;  // data mapped from id (not raster)
	private Map<CropType, CropUsageData> cropUsageData;
	private TripleMap<Integer, LandCoverType, LandCoverType, Double> landCoverChanges;
	private List<ForestRecord> newForest;
	private DoubleMap<Integer, LandCoverType, Double> reservedDeforested;
	private double netCarbonFlux;
	private double timberProduction;
	
	public GamsLocationOutput(ModelStat status, 
			Map<Integer, LandUseItem> landUses, 
			Map<CropType, CropUsageData> cropUsageData,
			TripleMap<Integer, LandCoverType, LandCoverType, Double> landCoverChange,
			List<ForestRecord> newForest,
			DoubleMap<Integer, LandCoverType, Double> reservedDeforested,
			double netCarbonFlux, double timberProduction) {
		super();
		this.status = status;
		this.landUses = landUses;
		this.cropUsageData = cropUsageData;
		this.landCoverChanges = landCoverChange;
		this.newForest = newForest;
		this.reservedDeforested = reservedDeforested;
		this.netCarbonFlux = netCarbonFlux;
		this.timberProduction = timberProduction;
	}
	
	public ModelStat getStatus() {
		return status;
	}
	public Map<Integer, LandUseItem> getLandUses() {
		return landUses;
	}

	public Map<CropType, CropUsageData> getCommoditiesData() {
		return cropUsageData;
	}
	
	public TripleMap<Integer, LandCoverType, LandCoverType, Double> getLandCoverChanges() {
		return landCoverChanges;
	}
	
	public List<ForestRecord> getNewForest() {
		return newForest;
	}
	
	public DoubleMap<Integer, LandCoverType, Double> getReservedDeforested() {
		return reservedDeforested;
	}
	
	public double getNetCarbonFlux() {
		return netCarbonFlux;
	}
	
	public double getTimberProduction() {
		return timberProduction;
	}
}
