package ac.ed.lurg.country.gams;

import java.util.List;
import java.util.Map;

import com.gams.api.GAMSGlobals.ModelStat;

import ac.ed.lurg.country.ForestRecord;
import ac.ed.lurg.landuse.CropUsageData;
import ac.ed.lurg.landuse.LandUseItem;
import ac.ed.lurg.types.CropType;
import ac.ed.lurg.types.LandCoverType;
import ac.ed.lurg.utils.DoubleMap;
import ac.sac.raster.RasterSet;

public class GamsRasterOutput {
	
	private ModelStat status;
	private RasterSet<LandUseItem> landUses;
	private Map<CropType, CropUsageData> cropUsageData;
	private List<ForestRecord> newForest;
	DoubleMap<Integer, LandCoverType, Double> reservedDeforested;
	double netCarbonFlux;
	double timberProduction;

	public GamsRasterOutput(RasterSet<LandUseItem> landUses, Map<CropType, CropUsageData> cropUsageData) {
		super();
		this.landUses = landUses;
        this.cropUsageData = cropUsageData; 
	}

	public GamsRasterOutput(ModelStat status, RasterSet<LandUseItem> intensityRaster, Map<CropType, CropUsageData> cropUsageData,
			List<ForestRecord> newForest, DoubleMap<Integer, LandCoverType, Double> reservedDeforested,
			double netCarbonFlux, double timberProduction) {
		this(intensityRaster, cropUsageData);
		this.status = status;
		this.newForest = newForest;
		this.reservedDeforested = reservedDeforested;
		this.netCarbonFlux = netCarbonFlux;
		this.timberProduction = timberProduction;
	}
	
	public ModelStat getStatus() {
		return status;
	}
	
	public RasterSet<LandUseItem> getLandUses() {
		return landUses;
	}

	public Map<CropType, CropUsageData> getCropUsageData() {
		return cropUsageData;
	}
	
	public List<ForestRecord> getNewForest() {
		return newForest;
	}
	
	public DoubleMap<Integer, LandCoverType, Double> getReservedDeforested() {
		return reservedDeforested;
	}
	
	public double getNetCarbonFlux() {
		return netCarbonFlux;
	}

	public double getTimberProduction() {
		return timberProduction;
	}
	
}
