package ac.ed.lurg.landuse;

import ac.sac.raster.RasterItem;
import java.util.HashMap;
import java.util.Map;

import ac.ed.lurg.types.LandCoverType;

public class CarbonFluxItem implements RasterItem {
	Map<LandCoverType, Map<LandCoverType, Double>> carbonFluxes = new HashMap<LandCoverType, Map<LandCoverType, Double>>(); 
	
	public void setCarbonFlux(LandCoverType previousLandCover, LandCoverType newLandCover, double carbonFlux) {
		
		if (carbonFluxes.containsKey(previousLandCover)) {
			carbonFluxes.get(previousLandCover).put(newLandCover, carbonFlux);
		} else {
			Map<LandCoverType, Double> cfMap = new HashMap<LandCoverType, Double>();
			cfMap.put(newLandCover, carbonFlux);
			carbonFluxes.put(previousLandCover, cfMap);
		}
	}
	
	public double getCarbonFlux(LandCoverType previousLandCover, LandCoverType newLandCover) {
		return carbonFluxes.get(previousLandCover).get(newLandCover);
	}
	
	public boolean checkForKeys(LandCoverType previousLandCover, LandCoverType newLandCover) {
		if (carbonFluxes.containsKey(previousLandCover)) {
			if (carbonFluxes.get(previousLandCover).containsKey(newLandCover)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
	
	public Map<LandCoverType, Map<LandCoverType, Double>> getCarbonFluxes() {
		return carbonFluxes;
	}

}
