package ac.ed.lurg.landuse;

import java.util.HashMap;
import java.util.Map;

import ac.ed.lurg.types.LandCoverType;

public class LandCoverChangeItem {
	private Map<Integer, Map<LandCoverType, Map<LandCoverType, Double>>> landCoverChange = new HashMap<Integer, Map<LandCoverType, Map<LandCoverType, Double>>>();
	
	public LandCoverChangeItem() {}
	
	public void setLandCoverChange(LandCoverType fromLC, LandCoverType toLC, Integer locId, double change) {
		
		if (landCoverChange.containsKey(locId)) {
			Map<LandCoverType, Map<LandCoverType, Double>> locMap = landCoverChange.get(locId);
			
			if (locMap.containsKey(fromLC)) {
				locMap.get(fromLC).put(toLC, change);
			} 
			else {
				Map<LandCoverType, Double> toMap = new HashMap<LandCoverType, Double>();
				toMap.put(toLC, change);
				
				landCoverChange.get(locId).put(fromLC, toMap);
			}
		}
		else {
			Map<LandCoverType, Double> toMap = new HashMap<LandCoverType, Double>();
			toMap.put(toLC, change);
			
			Map<LandCoverType, Map<LandCoverType, Double>> fromMap = new HashMap<LandCoverType, Map<LandCoverType, Double>>();
			fromMap.put(fromLC, toMap);
			
			landCoverChange.put(locId, fromMap);
		}
	}
	
	public double getLandCoverChange(LandCoverType fromLC, LandCoverType toLC, Integer locId) {
		return landCoverChange.get(locId).get(fromLC).get(toLC);
	}
	
	public Map<LandCoverType, Map<LandCoverType, Double>> getLandCoverChangeForLocation(Integer locId) {
		return landCoverChange.get(locId);
	}
}
