package ac.ed.lurg.landuse;

import java.util.HashMap;
import java.util.Map;

import ac.ed.lurg.types.LandCoverType;
import ac.sac.raster.RasterItem;

public class WoodYieldItem implements RasterItem {
	Map<LandCoverType, Map<LandCoverType, Double>> woodYields = new HashMap<LandCoverType, Map<LandCoverType, Double>>(); 
	
	public void setWoodYield(LandCoverType previousLandCover, LandCoverType newLandCover, double woodYield) {
		if (woodYields.containsKey(previousLandCover)) {
			woodYields.get(previousLandCover).put(newLandCover, woodYield);
		} else {
			Map<LandCoverType, Double> cfMap = new HashMap<LandCoverType, Double>();
			cfMap.put(newLandCover, woodYield);
			woodYields.put(previousLandCover, cfMap);
		}
	}
	
	public double getWoodYield(LandCoverType previousLandCover, LandCoverType newLandCover) {
		return woodYields.get(previousLandCover).get(newLandCover);
	}
	
	public boolean checkForKeys(LandCoverType previousLandCover, LandCoverType newLandCover) {
		if (woodYields.containsKey(previousLandCover)) {
			if (woodYields.get(previousLandCover).containsKey(newLandCover)) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

}
