package ac.ed.lurg.types;

import java.util.HashMap;
import java.util.Map;

import ac.ed.lurg.utils.LogWriter;

public enum GamsLandCoverType {
	TIMBER_FOREST("timberForest"),
	CARBON_FOREST("carbonForest"),
	NATURAL("natural"),
	PASTURE("pasture"),
	CROPLAND("cropland");
	
	private String name;
	
	GamsLandCoverType(String name) {
		this.name = name;
	}
	
	public String getName() {
		return name;
	}
	
	private static final Map<String, GamsLandCoverType> nameCache = new HashMap<String, GamsLandCoverType>();
    static {
        for (GamsLandCoverType c : values()) {
        	nameCache.put(c.getName(), c);
       }
    }
    
	private static GamsLandCoverType getFromCache(Map<String, GamsLandCoverType> cache, String name) {
		GamsLandCoverType type = cache.get(name);
		
		if (type == null)
			LogWriter.printlnError("Can't find Item for " + name);
		
		return type;
	}
    
	public static GamsLandCoverType getForName(String name) {
		return getFromCache(nameCache, name);
	}
}

