package ac.ed.lurg.types;

import java.util.Collection;
import java.util.HashSet;

public enum NonCropType {
	TIMBER_FOREST("timberForest", true, true),
	CARBON_FOREST("carbonForest", true, true),
	NATURAL("natural", true, false);

	private String gamsName;
	private boolean isWoodProducing;
	private boolean isManagedForest;
	
	private NonCropType (String gamsName, boolean isWoodProducing, boolean isManagedForest) {
		this.gamsName = gamsName;
		this.isWoodProducing = isWoodProducing;
		this.isManagedForest = isManagedForest;
	}
	
	public String getGamsName() {
		return gamsName;
	}
	
	public boolean isWoodProducing() {
		return isWoodProducing;
	}
	
	public boolean isManagedForest() {
		return isManagedForest;
	}
	
	public static Collection<NonCropType> getWoodProducingTypes() {
		Collection<NonCropType> lu = new HashSet<NonCropType>();
		
		for (NonCropType c : values())
			if (c.isWoodProducing)
				lu.add(c);
		
		return lu;
	}
	
	public static Collection<NonCropType> getManagedForestTypes() {
		Collection<NonCropType> lu = new HashSet<NonCropType>();
		
		for (NonCropType c : values())
			if (c.isManagedForest)
				lu.add(c);
		
		return lu;
	}

}
